/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

enum CERTOBJECTS_type {
	KEY = 1,
	REQ,
	ROOTCA,
	SUBCA,
	CERT,
	CRL
};

extern char *CERTOBJECTS_endings[];

enum CERTOBJECTS_yesno {
	no = 0,
	yes
};

enum CERTOBJECTS_status {
     not_yet_valid = 1,
	 valid,
	 expired,
	 expire_in_1,
	 expire_in_10,
	 expire_in_30,
	 revoked,
	 invalid
};

struct CERTOBJECTS_t {
	struct CERTOBJECTS_t *next;
	int count;
	enum CERTOBJECTS_type type;
	char *data;
	enum CERTOBJECTS_yesno	smartcard;
	char *filename;
	char *pubkey_hash;			// ende Key
	enum CERTOBJECTS_yesno	has_key;
	char *subject_hash;
	char *subject;
	char *cn;				// ende Req
	char *issuer_hash;
	char *issuer;
	time_t time_not_after;
	enum CERTOBJECTS_status	status;		// ende Crl
	time_t time_not_before;
	char *serial;
	char *keyid_subject;
	char *keyid_issuer;
};

extern struct CERTOBJECTS_t *CERTOBJECTS;

extern char *CERT_extract_cn(char *subject);
extern char *CERT_get_info(enum CERTOBJECTS_type type, char *data, char *info);
extern char *CERT_get_subject(enum CERTOBJECTS_type type, char *data);
extern char *CERT_get_issuer(enum CERTOBJECTS_type type, char *data);
extern time_t CERT_time_not_after(enum CERTOBJECTS_type type, char *data);
extern time_t CERT_time_not_before(enum CERTOBJECTS_type type, char *data);
extern int CERT_read_objects(enum CERTOBJECTS_type type, char *path);
extern int CERT_create_objectlist(void);
extern int CERT_clear_objectlist(void);
extern int CERT_create_optionlist_certs(char **p_buffer_main, char *selected, int without_keys_also);
extern int CERT_create_optionlist_cas(char **p_buffer_main, char *selected, int by_subject);
