/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"

extern int certcertlist(void);


int certcertdel(void) {
	struct CERTOBJECTS_t *search_cert, *search_ca, *search_key;
	char text_in[2048], *text_out = NULL, *text_err = NULL;
	char *p_keyfilename, *pubkey_hash = NULL, *pubkey_filename = NULL;
	char filename[1024], linkname[1024], *p_caname = NULL, *p_buffer;
	char *linknames[] = { "index.txt", "index.txt.old", "index.txt.attr", "index.txt.attr.old", "serial", "serial.old", NULL };
	char **p_linknames;
	int used = 0;
	char *argv_insert[] = { BIN_INSERTCERTS, PATH_TEMP "/tmpcert", getvar("password"), NULL };
	char *argv_ssl[] = { BIN_OPENSSL, NULL };
	DIR *directory;
	struct dirent *directory_structur;

	// pruefen ob Name uebergeben wurde
	if(NULL == getvar("certname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 1 );
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

//printf("<br>suche Zertifikate<br>\n");
	if(NULL == CERTOBJECTS)
			CERT_create_objectlist();
	search_cert = CERTOBJECTS;

	while(NULL != search_cert) {
		 if(NULL != search_cert->filename && !strcmp(search_cert->filename, getvar("certname")))
			break;
		search_cert = search_cert->next;
	}

	if(NULL == search_cert) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 2);
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	if(search_cert->smartcard) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 3);
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}
//printf("<br>setze common name<br>\n");

	if(NULL != search_cert && NULL != search_cert->cn)
		setvar(search_cert->cn, "commonname");
//printf("<br>suche CA - Zertifikate<br>\n");
	// suche CA
	search_ca = CERTOBJECTS;

	while(NULL != search_ca && search_cert->type != ROOTCA) {

		if(		NULL != search_ca->subject_hash && NULL != search_cert->issuer_hash
			&&	(search_ca->type == ROOTCA || search_ca->type == SUBCA)
			&&	!strcmp(search_ca->subject_hash, search_cert->issuer_hash)) {
   			setvar(search_ca->cn, "cacommonname");
			p_caname = strdup(search_ca->filename);
			*index(p_caname, '.') = 0;
			break;
		}

		search_ca = search_ca->next;
	}
//printf("<br>suche CA - Zertifikate - fertig<br>\n");

	if(NULL == search_ca || !search_ca->has_key) {
		 setvar("<!--", "haskey_start");
		 setvar("-->", "haskey_end");
	}
//printf("<br>test f�r exec<br>\n");

	if(NULL != getvar("execute")) {

		if(NULL != p_caname) {
			// pruefe ob Passwort/Gueltigkeit

			if(NULL == getvar("password")) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 4, search_ca->cn);
				certcertlist();
				P_SITE = "certcertlist";
				return EXIT_FAILURE;
			}

			if(NULL == getvar("crldays")) {
		  		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 5);
				certcertlist();
				P_SITE = "certcertlist";
				return EXIT_FAILURE;
			}

			// Verwaltungslinks herstellen
			p_linknames = linknames;

			while(NULL != *p_linknames) {
				snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s.%s", p_caname, *p_linknames);
				snprintf(linkname, sizeof(linkname) - 1, CERT_PATH "/%s", *p_linknames);
				unlink(linkname);

				if(link(filename, linkname)) {
					set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 6);
					certcertlist();
					P_SITE = "certcertlist";
					return EXIT_FAILURE;
				}

				p_linknames++;
			}

			p_keyfilename = strdup(search_ca->filename);
			strcpy(index(p_keyfilename, '-'), ".key");


			// Zertifikat revokieren
			snprintf(text_in, sizeof(text_in), "ca -config " CONF_OPENSSL " -revoke %s -keyfile %s -cert %s -key \"%s\"",
				search_cert->filename, p_keyfilename, search_ca->filename, getvar("password"));

			p_buffer = (char *) get_current_dir_name();
			chdir(CERT_PATH);

			if(		exec_command(text_in, &text_out, &text_err, argv_ssl, NULL)
				|| (NULL != text_err && NULL == strstr(text_err, "Data Base Updated"))) {

				if(NULL != text_err)
					set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_ssl[0], text_err);

				chdir(p_buffer);
				certcertlist();
				P_SITE = "certcertlist";
				return EXIT_FAILURE;
			}

			chdir(p_buffer);

			// CRL updaten
			// ssl ausfuehren
			snprintf(text_in, sizeof(text_in), "ca -config " CONF_OPENSSL " -gencrl -crldays %d -out " PATH_TEMP "/tmpcert.crl -keyfile %s -cert %s -key \"%s\"",
				atoi(getvar("crldays")), p_keyfilename, search_ca->filename, getvar("password"));

			p_buffer = (char *) get_current_dir_name();
			chdir(CERT_PATH);

			if(exec_command(text_in, &text_out, &text_err, argv_ssl, NULL)) {

				if(NULL != text_err)
					set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_ssl[0], text_err);

				chdir(p_buffer);
				certcertlist();
				P_SITE = "certcertlist";
				return EXIT_FAILURE;
			}
			chdir(p_buffer);

			// CRL in Zertifikatsspeicher
			if(exec_command(NULL, &text_out, &text_err, argv_insert, NULL)) {

				if(NULL != text_err)
					set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_insert[0], text_err);

				certcertlist();
				P_SITE = "certcertlist";
				return EXIT_FAILURE;
			}

			// Verwaltungslinks herstellen
			p_linknames = linknames;

			while(NULL != *p_linknames) {
				snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s.%s", p_caname, *p_linknames);
				snprintf(linkname, sizeof(linkname) - 1, CERT_PATH "/%s", *p_linknames);
				unlink(filename);
				if(link(linkname, filename)) {
					set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 6);
					break;
				}
				p_linknames++;
			}
		}

		// Schluessel suchen
		if(NULL != search_cert && NULL != search_cert->pubkey_hash) {
			pubkey_hash = strdup(search_cert->pubkey_hash);
			search_key = CERTOBJECTS;

			while(NULL != search_key) {

				if(NULL != search_key->pubkey_hash && !strcmp(search_key->pubkey_hash, search_cert->pubkey_hash)) {

					if(search_key->type == KEY) {

						if(no == search_key->smartcard)
							pubkey_filename = strdup(search_key->filename);
					}

					else

						if(search_key != search_cert)
							used++;
				}

			 	search_key = search_key->next;
			}
		}

		snprintf(filename, sizeof(filename) - 1, "%s", getvar("certname"));

		if(NULL != index(filename, '.')) {
			*index(filename, '.') = 0;

			if(NULL != (directory = opendir(CERT_PATH))) {

				while(NULL != (directory_structur = readdir(directory))) {
//printf("<br>(%s) %s\n", filename, directory_structur->d_name);					 
					if(strstr(directory_structur->d_name, filename) == directory_structur->d_name) {
//printf(" ------------\n");
						snprintf(linkname, sizeof(linkname) - 1, CERT_PATH "/%s", directory_structur->d_name);
						unlink(linkname);
//printf("cert: unlink(%s)", linkname);
					}
				}

				closedir(directory);
			}

		}

		if(!used && NULL != pubkey_filename) {
			snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", pubkey_filename);
			unlink(filename);
//printf("key: unlink(%s), used: %d", filename, used);
			syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: delete certificate %s with privat key", "USRNAME", getvar("commonname"));
		}

		else
	        syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: delete certificate %s", "USRNAME", getvar("commonname"));

		CERT_clear_objectlist();
		certcertlist();
		P_SITE = "certcertlist";
	}

	return EXIT_SUCCESS;
}
