/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"


extern int certcertlist(void);

int certcertexport(void) {
	char *text_out, *text_err;
	char filename[1024], buffer[1024];
	struct stat statbuf;
	char *argv_ssl[] = { BIN_OPENSSL, NULL };
	struct CERTOBJECTS_t *search_certobject, *search_rca;

	setvar("<!--", "nop12_start");
	setvar("-->", "nop12_end");

	if(NULL == getvar("certname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 11);
		syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: export certificate failed", "USRNAME");
		 // in Liste wechseln
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", getvar("certname"));

	if(NULL != index(filename, '-')) {
		*index(filename, '-') = 0;
		strcat(filename, ".key");

		if(stat(filename, &statbuf)) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 12);
			certcertlist();
			P_SITE = "certcertlist";
			return EXIT_FAILURE;
		}
	}

	else {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 13);
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}


	if(NULL == CERTOBJECTS)
		CERT_create_objectlist();
		
	search_certobject = CERTOBJECTS;

	while(NULL != search_certobject) {

		 if(NULL != search_certobject->filename && !strcmp(search_certobject->filename, getvar("certname")))
		 	break;
		 search_certobject = search_certobject->next;
	}

	if(NULL != search_certobject && NULL != search_certobject->cn)
		setvar(search_certobject->cn, "commonname");

	else {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 14);
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	if(NULL != getvar("password") || NULL != getvar("password1") || NULL != getvar("keypassword")) {

		if(NULL == getvar("password") || NULL == getvar("password1") || strcmp(getvar("password"), getvar("password1"))) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 15);
			return EXIT_FAILURE;
		}
	
		setvar(search_certobject->data, "_certs_");
		addvar("\n", "_certs_");
		search_rca = CERTOBJECTS;

		while(search_certobject != NULL && search_certobject->type != ROOTCA) {
			search_rca = CERTOBJECTS;

			while(NULL != search_rca) {

				if(		(search_rca->type == SUBCA || search_rca->type == ROOTCA)
					&&	!strcmp(search_certobject->issuer_hash, search_rca->subject_hash)) {
					addvar(search_rca->data, "_certs_");
					addvar("\n", "_certs_");
					break;
				}

				search_rca = search_rca->next;
			}

			search_certobject = search_rca;
		}

		save_var_as_file(PATH_TEMP "/tmp.certs", "_certs_");

		snprintf(buffer, sizeof(buffer) - 1, "pkcs12 -export -in " PATH_TEMP "/tmp.certs -out \"" WWW_ROOT WWW_CERT_PATH \
			"/%s.p12\" -passout \"pass:%s\" ", getvar("commonname"), getvar("password"));

		setvar(buffer, "sslstring");
		snprintf(buffer, sizeof(buffer) - 1, "-inkey %s -passin \"pass:%s\"", filename, getvar("keypassword"));
		addvar(buffer, "sslstring");

		addvar("\n", "sslstring");
//printf("<br>%s<br>\n", getvar("sslstring")); 		

		if(exec_command(getvar("sslstring"), &text_out, &text_err, argv_ssl, NULL) || NULL != strstr(text_err, "error")) {
			set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_ssl[0], text_err);
			return EXIT_FAILURE;
		}
		
		setvar("", "nop12_start");
		setvar("", "nop12_end");
		
		syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: export certificate %s as PKCS12", "USRNAME", getvar("commonname"));
	}

	return EXIT_SUCCESS;
}
