/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"


extern int certcertlist(void);

int certcertexportview(void) {
	char *text_out, *text_err, *p_name;
	char filename[1024], linkname[1024], password[64];
	struct stat statbuf;
	struct CERTOBJECTS_t *search_certobject;
	DIR *directory;
	struct dirent *directory_structur;
	char adminpassword[64] = {0}, userpassword[64] = {0}, path_cert[1024] = {0}, path_key[1024] = {0}, pass_key[64] = {0};
	char *argv_readcard[] = { BIN_READSMARTCARD, CERT_PATH_SC, NULL };
	char *argv_show_cert[] = { BIN_OPENSSL, "x509", "-noout", "-text", "-in", filename, NULL };
	char *argv_show_key[] = { BIN_OPENSSL, "rsa", "-text", "-in", filename, "-passin", password, NULL };
	char *argv_store_cert[] = { BIN_PKSC15INIT, "--store-certificate", path_cert, "--so-pin", \
								adminpassword, "--pin", userpassword, NULL, NULL };
	char *argv_store_key[] = { BIN_PKSC15INIT, "--store-private-key", path_key, "--so-pin", \
								adminpassword, "--pin", userpassword, "--passphrase", pass_key, "--auth-id", "01" ,NULL };

//pkcs15-init --store-certificate 9ce486f778282e68aaf07581e263735e-4a8bd988-ebd4f3fc-01.sca --so-pin 12345678 --pin 123456

	if(NULL == getvar("certname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 21);
		syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: show certificate request failed", "USRNAME");
		 // in Liste wchseln
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	// wenn aufsmartcard, export auf smartcard ausblenden
	if(NULL != index(getvar("certname"), '_')) {
		setvar("<!--", "noexport_start");
		setvar("-->", "noexport_end");
	}
	
	if(NULL == CERTOBJECTS)
		CERT_create_objectlist();

	search_certobject = CERTOBJECTS;

	while(NULL != search_certobject) {

		 if(NULL != search_certobject->filename && !strcmp(search_certobject->filename, getvar("certname")))
		 	break;

		 search_certobject = search_certobject->next;
	}
	if(NULL != search_certobject && NULL != search_certobject->cn)
		setvar(search_certobject->cn, "commonname");

	else {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 22);
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	if(search_certobject->type == ROOTCA || search_certobject->type == SUBCA)
		argv_store_cert[7] = "--authority";

	if(NULL == index(getvar("certname"), '_'))
		snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", getvar("certname"));

	else
		snprintf(filename, sizeof(filename) - 1, CERT_PATH_SC "/%s", getvar("certname"));

	if(exec_command(NULL, &text_out, &text_err, argv_show_cert, NULL)) {

		if(NULL != text_err)
			set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_show_cert[0], text_err);

		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	setvar(text_out, "certtext");
	read_file_in_var(filename, "text");
	addvar(getvar("text"), "certtext");

	if(NULL != index(filename, '-')) {
		*index(filename, '-') = 0;
		strcat(filename, ".key");

		if(!stat(filename, &statbuf)) {

			if(NULL != getvar("password") && strlen(getvar("password"))) {
				snprintf(password, sizeof(password) - 1, "pass:%s", getvar("password"));

				if(exec_command(NULL, &text_out, &text_err, argv_show_key, NULL)) {
					if(NULL != text_err){
//						set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_show_key[0], text_err);
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 23);
						setvar("<!--", "nokey_nopass_start");
						setvar("-->", "nokey_nopass_end");
					}
				}
				else {
					read_file_in_var(filename, "_data_");
					addvar(getvar("_data_"), "certtext");
				}
			}

		}
		else {
			setvar("<!--", "nokey_start");
			setvar("-->", "nokey_end");
		}

	}
	else {
		 setvar("<!--", "nokey_start");
		 setvar("-->", "nokey_end");
	}

	if(NULL != getvar("noexport_start")) {
		 setvar("", "nokey_start");
		 setvar("", "nokey_end");
	}

	if(NULL == getvar("password") || NULL != getvar("nokey_start")) {
		 setvar("<!--", "nokey_nopass_start");
		 setvar("-->", "nokey_nopass_end");
	}
	else {
		snprintf(linkname, sizeof(linkname) - 1, PATH_TEMP "/%s.key", getvar("commonname"));
		symlink(filename, linkname);
		snprintf(path_key, sizeof(path_key) - 1, "%s", filename);
		snprintf(pass_key, sizeof(pass_key) - 1, "%s", getvar("password"));
	}

	snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", getvar("certname"));
	snprintf(linkname, sizeof(linkname) - 1, PATH_TEMP "/%s.crt", getvar("commonname"));
	symlink(filename, linkname);
	snprintf(path_cert, sizeof(path_cert) - 1, "%s", filename);

// Export auf Smartcard
	if(NULL != getvar("adminpassword") || NULL != getvar("userpassword")) {
		snprintf(adminpassword, sizeof(adminpassword) - 1, "%s", getvar("adminpassword"));
		snprintf(userpassword, sizeof(userpassword) - 1, "%s", getvar("userpassword"));

		if(NULL != (p_name = rindex(path_cert, '/'))) {
			p_name++;
			if(NULL != (directory = opendir(CERT_PATH_SC))) {

				while(NULL != (directory_structur = readdir(directory)))
					if(NULL != strstr(directory_structur->d_name, p_name)) {
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 24);
						*path_cert = 0;
					}
			}

			closedir(directory);
		
			if(!strlen(adminpassword) || !strlen(userpassword)) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 25);
				return EXIT_FAILURE;
			}

			if(strlen(path_cert)) {

				if(exec_command(NULL, &text_out, &text_err, argv_store_cert, NULL)) {
					if(NULL != text_err)
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 26, argv_store_cert[0], text_err);
					return EXIT_FAILURE;
				}
			}
		}

		if(NULL != (p_name = rindex(path_key, '/'))) {
			p_name++;
			if(NULL != (directory = opendir(CERT_PATH_SC))) {
				while(NULL != (directory_structur = readdir(directory))) {
					if(NULL != strstr(directory_structur->d_name, p_name)) {
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 27);
						*path_key = 0;
					}
				}
			}
			closedir(directory);

			if(strlen(path_key) && strlen(pass_key)) {
				if(exec_command(NULL, &text_out, &text_err, argv_store_key, NULL)) {
					if(NULL != text_err)
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 28, argv_store_key[0], text_err);
					return EXIT_FAILURE;
				}
			}

		}

		// Smartcard erneut einlesen
		if(exec_command(NULL, &text_out, &text_err, argv_readcard, NULL)) {
			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_readcard[0], text_err);
			return EXIT_FAILURE;
		}
	}

	syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: show certificate %s", "USRNAME", getvar("commonname"));

	return EXIT_SUCCESS;
}

