/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"


int certcertlist(void) {
	struct CERTOBJECTS_t *search_certobject_main, *search_certobject_sub;
	enum CERTOBJECTS_type type_main, type_sub;
	char *p_buffer_main = NULL, *p_buffer_sub = NULL, buffer[1024];

	syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: list certificates", "USRNAME");

	if(NULL == CERTOBJECTS)
		CERT_create_objectlist();

	if(NULL != CERTOBJECTS) {

		for(type_main = ROOTCA; type_main <= CERT; type_main++) {
			search_certobject_main = CERTOBJECTS;
			do {
				// RootCAs suchen
				if(		search_certobject_main->type == type_main
					&&	(search_certobject_main->type != CERT || !search_certobject_main->count)
				) {

					snprintf(buffer, sizeof(buffer), "<option value=\"%s\" title=\"%s\">%s [%s ", \
						search_certobject_main->filename, search_certobject_main->subject, \
						search_certobject_main->cn, search_certobject_main->serial);
//printf("MAIN=\"%s\" title=\"%s\"%s<br>\n",search_certobject_main->filename, search_certobject_main->subject, search_certobject_main->cn);

					if(		search_certobject_main->smartcard
						||	search_certobject_main->has_key
						||	search_certobject_main->type == SUBCA
						||	search_certobject_main->type == ROOTCA
						||	(search_certobject_main->type != ROOTCA && !search_certobject_main->count)) {

						if(		(search_certobject_main->type != ROOTCA && !search_certobject_main->count)
							||	search_certobject_main->status != valid)
							strcat(buffer, "!");

						if(search_certobject_main->type == ROOTCA)
							strcat(buffer, "C");

						if(search_certobject_main->type == SUBCA)
							strcat(buffer, "c");

						if(search_certobject_main->smartcard)
							strcat(buffer, "s");

						if(search_certobject_main->has_key)
							strcat(buffer, "k");
					}

					strcat(buffer, "]");
					search_certobject_main->count++;

					if(p_buffer_main != NULL) {
						p_buffer_main = realloc(p_buffer_main, strlen(p_buffer_main) + strlen(buffer) + 1);
						strcat(p_buffer_main, buffer);
					}
					else {
						p_buffer_main = malloc(strlen(buffer) + 1);
						strcpy(p_buffer_main, buffer);
					}
					// SubCAs/Identzertifikate f�r RootCA suchen / Identzertifikate f�r SubCA suchen

					for(type_sub = type_main; type_sub <= CERT; type_sub++) {
						search_certobject_sub = CERTOBJECTS;
						while(NULL != search_certobject_sub->next) {
							search_certobject_sub = search_certobject_sub->next;
							if(		search_certobject_sub != search_certobject_main
								&&	search_certobject_sub->type == type_sub
								&&	!strcmp(search_certobject_sub->issuer_hash, search_certobject_main->subject_hash)
								&&	!strcmp(search_certobject_sub->keyid_issuer, search_certobject_main->keyid_subject)
							) {
								snprintf(buffer, sizeof(buffer), "<option value=\"%s\" title=\"%s\">&nbsp;&nbsp;&nbsp;%s [%s", 
									search_certobject_sub->filename, search_certobject_sub->subject, \
									search_certobject_sub->cn, search_certobject_sub->serial);
//printf("SUB=\"%s\" title=\"%s\"%s<br>\n",search_certobject_sub->filename, search_certobject_sub->subject, search_certobject_sub->cn);								
								if(		search_certobject_sub->smartcard
									||	search_certobject_sub->has_key
									||	search_certobject_sub->type == SUBCA
									||	search_certobject_sub->status != valid
								) {
									strcat(buffer, " ");

									if(search_certobject_sub->status != valid)
										strcat(buffer, "!");

									if(search_certobject_sub->type == SUBCA)
										strcat(buffer, "c");

									if(search_certobject_sub->smartcard)
										strcat(buffer, "s");

									if(search_certobject_sub->has_key)
										strcat(buffer, "k");
								}

								strcat(buffer, "]");
								search_certobject_sub->count++;

								if(p_buffer_sub != NULL) {
									p_buffer_sub = realloc(p_buffer_sub, strlen(p_buffer_sub) + strlen(buffer) + 1);
									strcat(p_buffer_sub, buffer);
								}
								else {
									p_buffer_sub = malloc(strlen(buffer) + 1);
									strcpy(p_buffer_sub, buffer);
								}

							}
						}

						if(NULL != p_buffer_sub) {
							sort_optionlist(p_buffer_sub);
							p_buffer_main = realloc(p_buffer_main, strlen(p_buffer_main) + strlen(p_buffer_sub) + 1);
							strcat(p_buffer_main, p_buffer_sub);
							free(p_buffer_sub);
							p_buffer_sub = NULL;
						}
					}
				}
			} while(NULL != (search_certobject_main = search_certobject_main->next));
		}
	}

	if(p_buffer_main != NULL) {
		setvar(p_buffer_main, "certname");
		free(p_buffer_main);
	}

    return EXIT_SUCCESS;
}
