/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>          
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"


extern int certcertlist(void);

int certcrl(void) {
	 struct CERTOBJECTS_t *search_ca;
	 char *p_caname, *p_crlfilename, *p_keyfilename;
	 char buffer[4096], *p_buffer, *text_out, *text_err;
	 char *argv_ssl[] = { BIN_OPENSSL, NULL };
	 char *argv_insert[] = { BIN_INSERTCERTS, PATH_TEMP "/tmpcert", getvar("password"), NULL };
	 char filename[1024], linkname[1024];
	 char **pp_linkname, *linknames[] = { "index.txt", "index.txt.old", "index.txt.attr", "index.txt.attr.old", "serial", "serial.old", NULL };

	if(NULL == getvar("certname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 41);
		syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: show certificate request failed", "USRNAME");
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	if(NULL == CERTOBJECTS)
		CERT_create_objectlist();
	search_ca = CERTOBJECTS;

	while(NULL != search_ca) {
		 if(NULL != search_ca->filename && !strcmp(search_ca->filename, getvar("certname")))
		 	break;
		 search_ca = search_ca->next;
	}

	if(		NULL == search_ca || NULL == search_ca->filename
		|| 	(search_ca->type != ROOTCA && search_ca->type != SUBCA)
		||	NULL == index(search_ca->filename, '.')
	) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 42);
		certcertlist();
		P_SITE = "certcertlist";
		return EXIT_FAILURE;
	}

	p_caname = strdup(search_ca->filename);
	*index(p_caname, '.') = 0;
	p_keyfilename = strdup(search_ca->filename);
	strcpy(index(p_keyfilename, '-'), ".key");
	p_crlfilename = strdup(search_ca->filename);
	strcpy(index(p_crlfilename, '.'), ".crl");

	// updaten
	if(NULL != getvar("execute") && !strcmp(getvar("execute"), "update")) {
		if(!search_ca->has_key) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 43);
			goto _read;
		}

		if(NULL == getvar("crldays") || atoi(getvar("crldays")) < 1 || atoi(getvar("crldays")) > 9999) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 44);
			goto _read;
		}
		

		if(NULL == getvar("password")) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 45);
			goto _read;
		}
		
		// Verwaltungs-Links erzeugen
		pp_linkname = linknames;

		while(NULL != *pp_linkname) {
			snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s.%s", p_caname, *pp_linkname);
			snprintf(linkname, sizeof(linkname) - 1, CERT_PATH "/%s", *pp_linkname);
				unlink(linkname);

				if(link(filename, linkname)) {
					set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 46);
					return EXIT_FAILURE;
				}

			pp_linkname++;
		}

		// ssl ausfuehren
		snprintf(buffer, sizeof(buffer), "ca -config " CONF_OPENSSL " -gencrl -crldays %d -out " PATH_TEMP "/tmpcert.crl -keyfile %s -cert %s -key \"%s\"",
			atoi(getvar("crldays")), p_keyfilename, search_ca->filename, getvar("password"));

		p_buffer = (char *) get_current_dir_name();
		chdir(CERT_PATH);

		if(exec_command(buffer, &text_out, &text_err, argv_ssl, NULL)) {
			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_ssl[0], text_err);
			chdir(p_buffer);
			goto _read;
		}

		chdir(p_buffer);

		// Zertifikat in Zertifikatsspeicher
		if(exec_command(NULL, &text_out, &text_err, argv_insert, NULL)) {
			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_insert[0], text_err);
			return EXIT_FAILURE;
		}
	
		goto _read;
	}

	if(NULL != getvar("execute") && !strcmp(getvar("execute"), "import")) {

		if((NULL == getvar("upload_size") || 0 == atoi(getvar("upload_size")) || NULL == getvar("upload_pointer"))) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 47);
			goto _read;
		}

		if(save_var_as_file(PATH_TEMP "/tmpcert.crl", "upload_pointer")) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 48);
			goto _read;
		}

  // CRL in Zertifikatsspeicher
		if(exec_command(NULL, &text_out, &text_err, argv_insert, NULL) || NULL != text_err) {

			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_insert[0], text_err);
			goto _read;
		}
		
		goto _read;
	}

_read:
	snprintf(buffer, sizeof(buffer) - 1, "crl -noout -text -in " CERT_PATH "/%s", p_crlfilename);

	if(!exec_command(buffer, &text_out, &text_err, argv_ssl, NULL) && NULL == text_err) {
		setvar(text_out, "crltext");
		snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", p_crlfilename);

		if(!read_file_in_var(filename, "_data_"))
			addvar(getvar("_data_"), "crltext");

		snprintf(linkname, sizeof(linkname) - 1, PATH_TEMP "/%s.crl", search_ca->cn);
		symlink(filename, linkname);
		setvar(search_ca->cn, "commonname");
	}
	else {
		 setvar("<!--", "nocrl_start");
		 setvar("-->", "nocrl_end");
	}

	if(search_ca->has_key) {
		 setvar("<!--", "haskey_start");
		 setvar("-->", "haskey_end");
	}
	else {
		 setvar("<!--", "hasnokey_start");
		 setvar("-->", "hasnokey_end");
	}

	return EXIT_SUCCESS;
}
