/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"

extern int certreqlist(void);


int certreqdel(void) {
	struct CERTOBJECTS_t *search_certobject;
	char *pubkey_hash = NULL, *pubkey_filename = NULL, filename[1024];
	int used = 0;

	// pruefen ob Requestname uebergeben wurde
	if(NULL == getvar("reqname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 51);
		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}

	if(NULL == CERTOBJECTS)
			CERT_create_objectlist();

	search_certobject = CERTOBJECTS;

	while(NULL != search_certobject) {
		 if(NULL != search_certobject->filename && !strcmp(search_certobject->filename, getvar("reqname")))
			break;
		search_certobject = search_certobject->next;
	}
	
	if(NULL == search_certobject) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 52);
		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}
	
	if(NULL != search_certobject && NULL != search_certobject->cn)
		setvar(search_certobject->cn, "commonname");

	if(NULL != getvar("execute")) {

		if(NULL != search_certobject && NULL != search_certobject->pubkey_hash) {
			pubkey_hash = strdup(search_certobject->pubkey_hash);
			search_certobject = CERTOBJECTS;

			while(NULL != search_certobject) {

				if(NULL != search_certobject->pubkey_hash && !strcmp(search_certobject->pubkey_hash, pubkey_hash)) {
					if(search_certobject->type == KEY) {
						if(no == search_certobject->smartcard)
							pubkey_filename = strdup(search_certobject->filename);
					}
					else
						if(search_certobject->type != REQ)
							used++;
				}

				search_certobject = search_certobject->next;
			}
		}
		
		snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", getvar("reqname"));
		unlink(filename);

		if(!used && NULL != pubkey_filename) {
			snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", pubkey_filename);
			unlink(filename);
			syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: delete certificate request %s with privat key", "USRNAME", getvar("commonname"));
		}
		else
			syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: delete certificate request %s", "USRNAME", getvar("commonname"));

		CERT_clear_objectlist();
		certreqlist();
		P_SITE = "certreqlist";

	}

	return EXIT_SUCCESS;

}
