/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"


extern int certreqlist(void);

int certreqexportview(void) {
	char *text_out, *text_err;
	char filename[1024], linkname[1024], password[64];
	struct stat statbuf;
	char *argv_show_req[] = { BIN_OPENSSL, "req", "-noout", "-text", "-in", filename, NULL };
	char *argv_show_key[] = { BIN_OPENSSL, "rsa", "-text", "-in", filename, "-passin", password, NULL };
	struct CERTOBJECTS_t *search_certobject;

	if(NULL == getvar("reqname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 55);
		syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: show certificate request failed (no name givven)", "USRNAME");
		 // in Liste wchseln
		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}

	if(NULL == CERTOBJECTS)
		CERT_create_objectlist();

	search_certobject = CERTOBJECTS;

	while(NULL != search_certobject) {
		 if(NULL != search_certobject->filename && !strcmp(search_certobject->filename, getvar("reqname")))
		 	break;
		 search_certobject = search_certobject->next;
	}

	if(NULL != search_certobject && NULL != search_certobject->cn)
		setvar(search_certobject->cn, "commonname");
	else {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 56);
		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}

	snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", getvar("reqname"));

	if(exec_command(NULL, &text_out, &text_err, argv_show_req, NULL)) {

		if(NULL != text_err)
			set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_show_req[0], text_err);

		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}

	setvar(text_out, "reqtext");
	read_file_in_var(filename, "text");
	addvar(getvar("text"), "reqtext");

	if(NULL != index(filename, '-')) {
		*index(filename, '-') = 0;
		strcat(filename, ".key");

		if(!stat(filename, &statbuf)) {

			if(NULL != getvar("password") && strlen(getvar("password"))) {
				snprintf(password, sizeof(password) - 1, "pass:%s", getvar("password"));

				if(exec_command(NULL, &text_out, &text_err, argv_show_key, NULL)) {
					if(NULL != text_err)
						set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_show_key[0], text_err);
				}
				else {
					read_file_in_var(filename, "_data_");
					addvar(getvar("_data_"), "reqtext");
				}
			}
		}
		else {
			setvar("<!--", "nokey_start");
			setvar("-->", "nokey_end");
		}
	}
	else {
		 setvar("<!--", "nokey_start");
		 setvar("-->", "nokey_end");
	}

	if(NULL == getvar("password") || NULL != getvar("nokey_start")) {
		 setvar("<!--", "nokey_nopass_start");
		 setvar("-->", "nokey_nopass_end");
	}
	else {
		snprintf(linkname, sizeof(linkname) - 1, PATH_TEMP "/%s.key", getvar("commonname"));
		symlink(filename, linkname);
	}
	
	snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s", getvar("reqname"));
	snprintf(linkname, sizeof(linkname) - 1, PATH_TEMP "/%s.req", getvar("commonname"));
	symlink(filename, linkname);

	syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: show certificate request %s", "USRNAME", getvar("commonname"));
	
	return EXIT_SUCCESS;
}
