/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"

extern int certreqlist(void);


int certreqimport(void) {
	int with_key = 0;
	char text_in[2048], *text_out = NULL, *text_err = NULL;
	char *pubkey_req;
	char *argv_ssl[] = { BIN_OPENSSL, NULL };
	char *argv_insert[] = { BIN_INSERTCERTS, WWW_ROOT WWW_CERT_PATH "/tmpcert", getvar("password"), NULL };
	char *p_start, *p_end;
	int count_req_start = 0, count_key_start = 0, count_req_end = 0, count_key_end = 0;
	char str_req_start[] = "-----BEGIN CERTIFICATE REQUEST-----";
	char str_req_end[] = "-----END CERTIFICATE REQUEST-----";
	char str_key_start[] = "-----BEGIN RSA PRIVATE KEY-----";
	char str_key_end[] = "-----END RSA PRIVATE KEY-----";
	char cmem;

	if(NULL != getvar("execute")) {
		if(		(NULL == getvar("reqfile_size") || 0 == atoi(getvar("reqfile_size")) || NULL == getvar("reqfile_pointer"))
			&&	NULL == getvar("text")
		) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 61);
			return EXIT_FAILURE;
		}

		if(NULL != getvar("reqfile_size") && 0 != atoi(getvar("reqfile_size")) && NULL != getvar("text")) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 62);
			return EXIT_FAILURE;
		}

		// importieren aus file-upload
		if(NULL == getvar("text")) {
			// request local speichern

			if(save_var_as_file(WWW_ROOT WWW_CERT_PATH "/tmpcert.req", "reqfile_pointer")) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 63);
				return EXIT_FAILURE;
			}

			// key local speichern		
			if(NULL != getvar("keyfile_size") && 0 != atoi(getvar("keyfile_size"))) {

				if(NULL == getvar("keyfile_pointer")) {
					set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 64);
					return EXIT_FAILURE;
				}

				if(save_var_as_file(WWW_ROOT WWW_CERT_PATH "/tmpcert.key", "keyfile_pointer")) {
					set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 65);
					return EXIT_FAILURE;
				}

				with_key = 1;
			}
		}
		// importieren aus Text
		else {
			// pruefe Format
			p_start = getvar("text");

			while(NULL != (p_start = strstr(p_start, str_req_start))) {
				count_req_start++;
				p_start++;
			}

			p_start = getvar("text");

			while(NULL != (p_start = strstr(p_start, str_req_end))) {
				count_req_end++;
				p_start++;
			}
			p_start = getvar("text");

			while(NULL != (p_start = strstr(p_start, str_key_start))) {
			 	count_key_start++;
				p_start++;
			}

			p_start = getvar("text");

			while(NULL != (p_start = strstr(p_start, str_key_end))) {
			 	count_key_end++;
				p_start++;
			}

			// teste auf Fehler			
			if(count_req_start != count_req_end || count_key_start != count_key_end) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 66);
				return EXIT_FAILURE;
			}

			if(!count_req_start) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 67);
				return EXIT_FAILURE;
			}

			if(count_req_start > 1) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 68);
				return EXIT_FAILURE;
			}

			if(count_key_start && count_key_start != 1) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 69);
				return EXIT_FAILURE;
			}

			//request local speichern
			p_start = strstr(getvar("text"), str_req_start);
			p_end = strstr(p_start, str_req_end) + sizeof(str_req_end);
			cmem = *p_end;
			*p_end = 0;
			setvar(p_start, "_data_");
			*p_end = cmem;
			save_var_as_file(WWW_ROOT WWW_CERT_PATH "/tmpcert.req", "_data_");
			
			//key local speichern
			if(count_key_start) {
				p_start = strstr(getvar("text"), str_key_start);
				p_end = strstr(p_start, str_key_end) + sizeof(str_key_end);
				cmem = *p_end;
				*p_end = 0;
				setvar(p_start, "_data_");
				*p_end = cmem;
				save_var_as_file(WWW_ROOT WWW_CERT_PATH "/tmpcert.key", "_data_");
				with_key = 1;
			}
		}

		// lese pubkey aus request
		snprintf(text_in, sizeof(text_in), "req -noout -pubkey -in " WWW_ROOT WWW_CERT_PATH "/tmpcert.req\n");

		if(exec_command(text_in, &text_out, &text_err, argv_ssl, NULL) || NULL != text_err) {
			set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_ssl[0], text_err);
			return EXIT_FAILURE;
		}

		if(NULL == (pubkey_req = text_out)) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 70, argv_ssl[0], text_err);
			return EXIT_FAILURE;
		}
		
		// wenn Schluessel, lese pubkey aus Schluessel, vergleiche pubkey
		if(with_key) {
			 if(NULL == getvar("password"))
			 	snprintf(text_in, sizeof(text_in), "rsa -pubout -in " WWW_ROOT WWW_CERT_PATH "/tmpcert.key\n");
			 else
			 	snprintf(text_in, sizeof(text_in), "rsa -pubout -in " WWW_ROOT WWW_CERT_PATH "/tmpcert.key -passin pass:%s\n", getvar("password"));

			 if(exec_command(text_in, &text_out, &text_err, argv_ssl, NULL) || (NULL != text_err && strcmp(text_err, "writing RSA key\n"))) {
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_ssl[0], text_err);
				return EXIT_FAILURE;
			}

			if(NULL == text_out) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 71, argv_ssl[0], text_err);
				return EXIT_FAILURE;
			}

			if(strcmp(text_out, pubkey_req)) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__,72 , argv_ssl[0], text_err);
				return EXIT_FAILURE;
			}
		}

		// Zertifikat in Zertifikatsspeicher
		if(exec_command(NULL, &text_out, &text_err, argv_insert, NULL)) {
			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_insert[0], text_err);
			return EXIT_FAILURE;
		}

		certreqlist();
		P_SITE = "certreqlist";
	}
	
	return EXIT_SUCCESS;
}
