/***************************************************************************
 *   Copyright (C) 2008 by msm net ingenieurbuero meissner   *
 *   service@msm-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <syslog.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dirent.h>

#include "main.h"
#include "CERT.h"

extern int certreqlist(void);


int certreqsign(void) {
	char *text_out, *text_err;
	struct CERTOBJECTS_t *search_certobject_main, *search_certobject_sub;
	enum CERTOBJECTS_type type_main;
	char **pp_buffer, *p_buffer, *p_buffer_main = NULL, *p_buffer_sub = NULL, buffer[8192];
	char *linknames[] = { "index.txt", "index.txt.old", "index.txt.attr", "index.txt.attr.old", "serial", "serial.old", NULL };
	char *p_start, *p_caname = NULL, filename[1024], linkname[1024];
	FILE *p_file;
	int smartcard = 0;
	char *argv_create_req[] = { BIN_OPENSSL, NULL };
	char *argv_insert[] = { BIN_INSERTCERTS, PATH_TEMP "/tmpcert", NULL, "sign", NULL };
																// !!!!!!!!!!!!!			

	// pruefen ob requestname uebergeben wurde
	if(NULL == getvar("reqname")) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 101);
		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}

	// pruefe, ob reqest exestiert / hole cn
	CERT_create_objectlist();
	search_certobject_main = CERTOBJECTS;

	while(search_certobject_main != NULL) {
		if(		NULL != search_certobject_main->filename
			&&	!strcmp(search_certobject_main->filename, getvar("reqname"))) {
			setvar(search_certobject_main->cn, "reqcommonname");
		 	break;
		}
		search_certobject_main = search_certobject_main->next;
	}

	if(NULL == search_certobject_main) {
		set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 102);
		certreqlist();
		P_SITE = "certreqlist";
		return EXIT_FAILURE;
	}
	
	// Liste unterzeichungs-faehiger CAs zusammenstellen
	if(NULL != CERTOBJECTS) {
		for(type_main = ROOTCA; type_main <= SUBCA; type_main++) {
			search_certobject_main = CERTOBJECTS;
			do {
				// RootCAs suchen
				if(search_certobject_main->type == type_main && search_certobject_main->has_key == yes) {
					snprintf(buffer, sizeof(buffer), "<option value=\"%s\" title=\"%s\">%s [%s", \
						search_certobject_main->filename, search_certobject_main->subject, \
						search_certobject_main->cn, search_certobject_main->serial);
					search_certobject_main->count++;
//printf("MAIN=\"%s\" title=\"%s\"%s<br>\n",search_certobject_main->filename, search_certobject_main->subject, search_certobject_main->cn);
					if(search_certobject_main->smartcard)
						strcat(buffer, " s");
					strcat(buffer, "]");
					if(p_buffer_main != NULL) {
						p_buffer_main = realloc(p_buffer_main, strlen(p_buffer_main) + strlen(buffer) + 1);
						strcat(p_buffer_main, buffer);
					}
					else {
						p_buffer_main = malloc(strlen(buffer) + 1);
						strcpy(p_buffer_main, buffer);
					}
					// SubCAs/Identzertifikate f�r RootCA suchen
						search_certobject_sub = CERTOBJECTS;
						while(NULL != search_certobject_sub->next) {
							search_certobject_sub = search_certobject_sub->next;
							if(     search_certobject_sub != search_certobject_main
								&&	search_certobject_sub->type == SUBCA && search_certobject_sub->has_key == yes
								&&	!strcmp(search_certobject_sub->issuer_hash, search_certobject_main->subject_hash)
								&&	!strcmp(search_certobject_sub->keyid_issuer, search_certobject_main->keyid_subject)
							) {
								snprintf(buffer, sizeof(buffer), "<option value=\"%s\" title=\"%s\">&nbsp;&nbsp;&nbsp;%s [%s",
									search_certobject_sub->filename, search_certobject_sub->subject, \
									search_certobject_sub->cn, search_certobject_sub->serial);
								search_certobject_sub->count++;
//printf("SUB=\"%s\" title=\"%s\"%s<br>\n",search_certobject_sub->filename, search_certobject_sub->subject, search_certobject_sub->cn);
								if(search_certobject_sub->smartcard)
									strcat(buffer, " s");
								strcat(buffer, "]");
								if(p_buffer_sub != NULL) {
									p_buffer_sub = realloc(p_buffer_sub, strlen(p_buffer_sub) + strlen(buffer) + 1);
									strcat(p_buffer_sub, buffer);
								}
								else {
									p_buffer_sub = malloc(strlen(buffer) + 1);
									strcpy(p_buffer_sub, buffer);
								}
							}
						}
						if(NULL != p_buffer_sub) {
							sort_optionlist(p_buffer_sub);
							p_buffer_main = realloc(p_buffer_main, strlen(p_buffer_main) + strlen(p_buffer_sub) + 1);
							strcat(p_buffer_main, p_buffer_sub);
							free(p_buffer_sub);
							p_buffer_sub = NULL;
						}
				}
			} while(NULL != (search_certobject_main = search_certobject_main->next));
		}
	}
	if(p_buffer_main != NULL) {
		setvar(p_buffer_main, "allidentcaname");
		setvar(p_buffer_main, "allcacaname");
		free(p_buffer_main);
	}

	// Ausfuehren
	if(NULL != getvar("execute")) {
		setvar("", "caname");
		setvar("", "key");
		setvar("", "crlDistributionPoints");
		
		if(NULL == getvar("ca_ident_cert") || (strcmp(getvar("ca_ident_cert"), "ident") && strcmp(getvar("ca_ident_cert"), "ca"))) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 103);
			return EXIT_FAILURE;
		}

		if(NULL == getvar("days") || !atoi(getvar("days"))) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 104);
			return EXIT_FAILURE;
		}
		
		// Einstellungen pruefen
		if(!strcmp(getvar("ca_ident_cert"), "ident")) {

			if(NULL == getvar("identcaname")) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 105);
				return EXIT_FAILURE;
			}
			setvar(getvar("identcaname"), "caname");

			if(NULL == getvar("identpassword")) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 106);
				return EXIT_FAILURE;
			}
			setvar(getvar("identpassword"), "password");
		}

		if(!strcmp(getvar("ca_ident_cert"), "ca")) {

			if(NULL != getvar("distributionpoint1") || NULL != getvar("distributionpoint2")) {
				setvar("crlDistributionPoints = ", "crlDistributionPoints");
				if(NULL != getvar("distributionpoint1")) {
					snprintf(buffer, sizeof(buffer) - 1, "URI:%s", getvar("distributionpoint1"));
					addvar(buffer, "crlDistributionPoints");
					if(NULL != getvar("distributionpoint2"))
						addvar(", ", "crlDistributionPoints");
				}
				if(NULL != getvar("distributionpoint2")) {
					snprintf(buffer, sizeof(buffer) - 1, "URI:%s", getvar("distributionpoint2"));
					addvar(buffer, "crlDistributionPoints");
				}
   			}

			if(NULL == getvar("catyp") || (strcmp(getvar("catyp"), "rootca") && strcmp(getvar("catyp"), "subca"))) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 107);
				return EXIT_FAILURE;
			}

			if(NULL == getvar("cacaname")) {
				if(!strcmp(getvar("catyp"), "subca")) {
					set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 108);
					return EXIT_FAILURE;
				}
			}
			else
				setvar(getvar("cacaname"), "caname");

			if(NULL == getvar("capassword")) {
				set_error(__FUNCTION__, __FILE__, __LINE__, 106);
				return EXIT_FAILURE;
			}

			setvar(getvar("capassword"), "password");
		}

		// find key for ca/req
		if(NULL != getvar("caname") && strlen(getvar("caname")))
			snprintf(buffer, sizeof(buffer) - 1, "%s", getvar("caname"));
		else 
			snprintf(buffer, sizeof(buffer) - 1, "%s", getvar("reqname"));

		if(NULL == index(buffer, '-')) {
			set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 109);
			return EXIT_FAILURE;
		}

		*index(buffer, '-') = 0;
		search_certobject_main = CERTOBJECTS;

		while(search_certobject_main != NULL) {

			if(		NULL != search_certobject_main->pubkey_hash
				&&	!strcmp(search_certobject_main->pubkey_hash, buffer)
			) {

				if((smartcard = search_certobject_main->smartcard) == yes) {

					if(NULL == (p_buffer = index(search_certobject_main->filename, '_'))) {
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 109);
						return EXIT_FAILURE;
					}
					snprintf(buffer, sizeof(buffer) - 1, "id_%s", p_buffer + 1);
					setvar(buffer, "key");
				}
				else
					setvar(search_certobject_main->filename, "key");
		 		break;
			}

			search_certobject_main = search_certobject_main->next;
		}


//printf("\n<br>%s<br>\n", getvar("caname"));
		// caname ohne endung
		if(NULL != getvar("caname")) {
			p_caname = strdup(getvar("caname"));

			if(NULL == index(p_caname, '.')) {
				set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 110);
				return EXIT_FAILURE;
			}

			*index(p_caname, '.') = 0;

			// Verwaltungs-Links erzeugen
			pp_buffer = linknames;

        		while(NULL != *pp_buffer) {
				snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s.%s", p_caname, *pp_buffer);
				snprintf(linkname, sizeof(linkname) - 1, CERT_PATH "/%s", *pp_buffer);
				    if(NULL == (p_file = fopen(filename, "a"))) {
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 111);
						return EXIT_FAILURE;
					}
					if(0L == ftell(p_file) && !strcmp(*pp_buffer, "serial"))
						fprintf(p_file, "02"); 
					fclose(p_file);
					unlink(linkname);
					if(link(filename, linkname)) {
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 112);
						return EXIT_FAILURE;
					}
				pp_buffer++;
			}

		}

		// Konfigurationsdatei vorbereiten
		read_file_in_var(CONF_OPENSSL, "_data_");
		fillin_vars(getvar("_data_"), "_text_", '#', '#');
//printf("<br><br>%s<br><br>\n", getvar("_text_"));
		save_var_as_file(PATH_TEMP "/openssl.cnf", "_text_");

		// ssl-string vorbereiten, wenn mit smartcard
		setvar("", "sslstring");

		if(smartcard)
			addvar("engine dynamic -pre SO_PATH:" PATH_PKCS11ENGINE \
				"-pre ID:pkcs11 -pre LIST_ADD:1 -pre LOAD\n", "sslstring");
			
		// selbstsigniertes zertifikat erstellen
		if(!strcmp(getvar("ca_ident_cert"), "ca") && !strcmp(getvar("catyp"), "rootca")) {
			addvar("x509 -set_serial 1 -req -extensions v3_ca -extfile " PATH_TEMP "/openssl.cnf -out " PATH_TEMP "/tmpcert.rca ", "sslstring");
			snprintf(buffer, sizeof(buffer) - 1, "-days %d -in %s -signkey %s ", \
				atoi(getvar("days")), getvar("reqname"), getvar("key"));
			addvar(buffer, "sslstring");

			if(smartcard) {
				addvar("-engine pkcs11 -keyform engine\n", "sslstring");
				snprintf(buffer, sizeof(buffer) - 1, "%s\n ", getvar("password"));
				addvar(buffer, "sslstring");
			}
			else {
				snprintf(buffer, sizeof(buffer) - 1, "-passin \"pass:%s\"\n ", getvar("password"));
				addvar(buffer, "sslstring");
			}
		}
        // request signieren
		else {
			addvar("ca -config " CONF_OPENSSL " -outdir . -batch -out " PATH_TEMP "/tmpcert.cert ", "sslstring");
			if(NULL != getvar("catyp") && !strcmp(getvar("catyp"), "subca")) 
				addvar("-extensions v3_ca -extfile " PATH_TEMP "/openssl.cnf ", "sslstring");
			snprintf(buffer, sizeof(buffer) - 1, "-days %d -in %s -cert %s -keyfile \"%s\" ", \
				atoi(getvar("days")), getvar("reqname"), getvar("caname"), getvar("key"));
			addvar(buffer, "sslstring");

			if(smartcard) {
				addvar("-engine pkcs11 -keyform engine\n", "sslstring");
				snprintf(buffer, sizeof(buffer) - 1, "%s\n ", getvar("password"));
				addvar(buffer, "sslstring");
			}
			else {
				snprintf(buffer, sizeof(buffer) - 1, "-key %s\n ", getvar("password"));
				addvar(buffer, "sslstring");
			}
		}

//printf("<br>%s<br>\n", getvar("sslstring"));
		// Zertifikat erstellen
		p_buffer = (char *)get_current_dir_name();
		chdir(CERT_PATH);

		if(exec_command(getvar("sslstring"), &text_out, &text_err, argv_create_req, NULL)) {
			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_create_req[0], text_err);
			chdir(p_buffer);
			return EXIT_FAILURE;
		}

		chdir(p_buffer);
//printf("%s<br><br>%s", text_out, text_err);

		// nur PEM-Daten
		if(!read_file_in_var(PATH_TEMP "/tmpcert.cert", "_data_")) {
			if(NULL != (p_start = strstr(getvar("_data_"), "-----BEGIN"))) {
				 setvar(p_start, "_text_");
				 save_var_as_file(PATH_TEMP "/tmpcert.cert", "_text_");
			}
		}
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		// Verwaltungsdatein setzen
		if(NULL != getvar("caname")) {
			pp_buffer = linknames;
			while(NULL != *pp_buffer) {
				snprintf(filename, sizeof(filename) - 1, CERT_PATH "/%s.%s", p_caname, *pp_buffer);
				snprintf(linkname, sizeof(linkname) - 1, CERT_PATH "/%s", *pp_buffer);
					if(unlink(filename))
						set_error(__FUNCTION__, __FILE__, __LINE__, "unlink: %s", strerror(errno));
					if(link(linkname, filename)) {
						set_error_multilang(__FUNCTION__, __FILE__, __LINE__, 112);
						return EXIT_FAILURE;
					}
				pp_buffer++;
			}
		}

		// Zertifikat in Zertifikatsspeicher
		argv_insert[2] = getvar("password");
		if(exec_command(NULL, &text_out, &text_err, argv_insert, NULL)) {
			if(NULL != text_err)
				set_error(__FUNCTION__, __FILE__, __LINE__, "%s:\n%s", argv_insert[0], text_err);
			return EXIT_FAILURE;
		}
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		syslog(LOG_DAEMON | LOG_INFO, "User: %s, Action: sign certificate request %s", "USRNAME", getvar("reqcommonname"));
		
        certreqlist();
		P_SITE = "certreqlist";
	}

    return EXIT_SUCCESS;
}
